<template id="template">
  <div id="menu-container">
    <div id="primary-heading">Select Your Options</div>
    <div id="secondary-heading">
      Are you a <small>beta</small> who will go easy, or an ALPHA who will go
      hard?
    </div>
    <section>
      <div id="categories-container" class="inner-container">
        <p>Trivia Category</p>
        <select id="select-categories" @change="onCategoryChange($event)">
          <option value="" selected>Any</option>
          <option v-for="category in categories" :key="category.id">
            {{ category.name }}
          </option>
        </select>
      </div>
    </section>
    <section>
      <div id="question-type-container" class="inner-container">
        <p>Question Type</p>
        <select
          id="select-trivia-type"
          @change="onTriviaTypeChange($event)"
          class="dropdown"
        >
          <option v-for="type in triviaTypes" :key="type.id">
            {{ type.text }}
          </option>
        </select>
      </div>
    </section>
    <section>
      <div id="difficulty-level-container" class="inner-container">
        <p>Difficulty Level</p>
        <select id="select-difficulty" @change="onDifficultyChange($event)">
          <option v-for="difficulty in difficulties" :key="difficulty.id">
            {{ difficulty.level }}
          </option>
        </select>
      </div>
    </section>
    <section>
      <div id="question-amount-container" class="inner-container">
        <p>Number of Questions</p>
        <input
          type="number"
          placeholder="10-50"
          v-model="selectedAmount"
          max="50"
        />
      </div>
    </section>
    <div id="button-container">
      <div @click="createSessionToken">
        <BaseButton :style-type="'secondary-dark'">Create Token</BaseButton>
      </div>
      <div @click="resetToken">
        <BaseButton :style-type="'secondary-dark'">Reset Token</BaseButton>
      </div>
      <div @click="startGame">
        <BaseButton id="start-game" :style-type="'secondary-dark'"
          >Start Game</BaseButton
        >
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { apiToken, getCategories, getGameQuestions } from "@/api/api";
import Vue from "vue";
import BaseButton from "../components/base/BaseButton.vue";
import { TriviaCategories } from "@/interfaces/category";
import { triviaTypes, difficulties } from "@/consts/triviaConsts";
import { Questions } from "@/interfaces/question";

export default Vue.extend({
  name: "Menu",
  components: {
    BaseButton
  },
  data() {
    return {
      selectedAmount: Number,
      selectedDifficulty: "easy",
      selectedType: "",
      selectedCategory: 0,
      categories: [] as TriviaCategories,
      questions: [] as Questions,
      triviaTypes: triviaTypes,
      difficulties: difficulties
    };
  },
  methods: {
    //  Creates session token
    async createSessionToken() {
      if (!this.tokenExists()) {
        const params = {
          command: "request"
        };
        const respData = await apiToken(params);
        localStorage.setItem("token", respData.token);
      }
    },
    //  Checks if token exists in localStorage
    tokenExists() {
      const token = localStorage.getItem("token");
      if (token === null) {
        return false;
      }
      return true;
    },

    // Resets token
    async resetToken() {
      if (!this.tokenExists()) {
        return;
      }
      const params = {
        command: "reset",
        token: localStorage.getItem("token")
      };
      await apiToken(params);
    },
    // Fetches categories from the API and assigns the data to categories variable

    onCategoryChange(event: any) {
      const category = this.categories.find(
        id => id.name === event.target.value
      );
      if (category) {
        this.selectedCategory = category.id;
      }
    },
    onTriviaTypeChange(event: any) {
      const triviaType = triviaTypes.find(
        type => type.text === event.target.value
      );
      if (triviaType) {
        this.selectedType = triviaType.type;
      }
    },
    onDifficultyChange(event: any) {
      this.selectedDifficulty = event.target.value.toLowerCase();
    },

    async startGame() {
      const params = {
        amount: +this.selectedAmount,
        category: this.selectedCategory,
        difficulty: this.selectedDifficulty,
        type: this.selectedType
      };

      const questions = await getGameQuestions(params);
      if (typeof questions == typeof "") {
        return alert(questions);
      }
      this.questions = questions as Questions;
      this.$store.commit("setQuestions", this.questions);
      this.$router.push("/game");
    }
  },
  async created() {
    this.categories = (await getCategories()) as TriviaCategories;
  }
});
</script>

<style scoped>
#menu-container {
  background-color: #aebfb7;
  align-items: center;
  justify-content: center;
  width: 40vw;
  padding: 1.4em;
  border-radius: 22px;
  margin: auto;
  font-family: "Staatliches";
}
#primary-heading {
  font-family: "Franklin Gothic Medium", "Arial Narrow", Arial, sans-serif;
  font-size: 2em;
  margin-bottom: 10px;
}
#secondary-heading {
  font-family: "Franklin Gothic Medium", "Arial Narrow", Arial, sans-serif;
  font-size: 1.3em;
  margin-bottom: 15px;
}

.inner-container {
  background-color: #357977;
  margin: auto;
  padding: 1em 1em;
  margin-bottom: 0.7em;
  border-radius: 22px;
  width: 60%;
}
.inner-container p {
  font-size: 1.2em;
  font-weight: bolder;
  margin-bottom: 0.5em;
  margin-top: 0.5em;
}
#button-container {
  display: flex;
  justify-content: space-evenly;
}

select {
  border: transparent;
  border-radius: 5px;
  text-align: center;
  width: 35%;
  min-width: 150px;
  margin-bottom: 0.5em;
}

input {
  border: transparent;
  border-radius: 5px;
  margin-bottom: 0.5em;
}
</style>
